(* QuickECheck Example for Project Demo
 *
 * Neil Wilkie
 * March 2005
 * 
 * A test which has an implication which doesn't use QCheck's special
 * treatment.
 *)

fun contains(s,c) = chelper(explode s, c)

and chelper(h::t, c) = if h = c
                       then true
                       else chelper(t, c)
  | chelper([], c)   = false;


fun getAfter(string, token) =
  implode(splitAfter(explode(string), token))

and splitAfter(h::t, token) =
      if h = token
      then t
      else splitAfter(t, token)
  | splitAfter([], token) = [];

fun appearsOnce(s, c) = contains(s, c) andalso
                        not (contains(getAfter(s, c), c))


fun reverse x = implode(helper(explode x))

and helper(h::t) = helper(t)@[h]
  | helper([])   = [];


fun eq(s0,s1) = s0 = s1;


qecheck "forall s:string.(exists t:char.appearsOnce(s, t) and even(size(s))) ==> not(eq(reverse(s),s))";