(* example2.sml
 *
 * Neil Wilkie 2004-05
 * Edinburgh University Informatics UG4 Project
 *
 * 'Random Testing of ML Programs'
 *
 * An example of QuickECheck using strings.
 *)

load "String";

(* Define functions for getting the string before and after the first occurence
 * of the token.
 *)

fun getBefore(string, token) =
      implode(splitBefore(explode(string), token, []))
                                 
and splitBefore(h::t, token, header) =
      if h = token
      then header
      else splitBefore(t, token, header@[h])
  | splitBefore([], token, header) = header

fun getAfter(string, token) =
  implode(splitAfter(explode(string), token))

and splitAfter(h::t, token) =
      if h = token
      then t
      else splitAfter(t, token)
  | splitAfter([], token) = [];
        

(* Define functions for checking if a certain character is in a string. *)

fun containedIn(string, token) =
      contains(explode(string), token)

and contains(h::t, token) = 
      if h = token
      then true
      else contains(t, token)
  | contains([], token) = false;

(* Specify a test. *)

(*qecheck "forall x:string.not(containedIn(getBefore(x,#\"a\"),#\"a\"))";

qecheck "forall x:string.forall y:char.(size(getBefore(x,y))+size(getAfter(x,y)))=size(x)";
*)
qecheck "forall x:string.forall y:char.(size(getBefore(x,y))+size(getAfter(x,y))+1)=size(x)";
(*
qecheck "forall x:string.forall y:char.(size(getBefore(x,y))+size(getAfter(x,y)))=size(x) or (size(getBefore(x,y))+size(getAfter(x,y))+1)=size(x)";*)